#include <SoftwareSerial.h>
#include <Servo.h>
#include "pirates2.h"

const int button1Pin = 5;
const int button2Pin = 6;
const int button3Pin = 7;
const int led1 = 13;
const int led2 = 4;
Servo myservo;
SoftwareSerial HM10(2, 3); // RX = 2, TX = 3
char appData;
String inData = "";
int pos = 0;
int trig=10;
int echo=11;
const int buzzer = 8;
int sensorTimer = 0;
int melodyTimer = 0;
bool sensorOn = true;
bool melodyOn = false;
int thisNote = 0;

void setup()
{
  pinMode(button1Pin, INPUT);
  pinMode(button2Pin, INPUT);
  pinMode(button3Pin, INPUT);

  digitalWrite(8,LOW);
  Serial.begin(9600);
  Serial.println("HM10 serial started at 9600");
  HM10.begin(9600);

  myservo.attach(9);
  pinMode(9, OUTPUT);

  pinMode(led1, OUTPUT);
  digitalWrite(led1, LOW);
  pinMode(led2, OUTPUT);
  digitalWrite(led2, LOW);
  myservo.write(45);

  pinMode(buzzer, OUTPUT); // Set buzzer - pin 8 as an output

  pinMode(trig,OUTPUT);
  pinMode(echo,INPUT);
}

void loop()
{
  
  if (digitalRead(button1Pin) == HIGH && melodyTimer > 3 + (!sensorOn * !melodyOn * 4000) + !melodyOn * 10) {
    Serial.println(melodyTimer);
    melodyOn = !melodyOn;
    thisNote = 0;
    melodyTimer = 0;  
  }
  
  melodyTimer++;
  
  if (melodyOn) {
    const int currentNote = notes[thisNote];
    float wait = durations[thisNote] / songSpeed;
    
    if (currentNote != 0)
    {
      tone(buzzer, notes[thisNote], wait); // tone(pin, frequency, duration)
    }
    else
    {
      noTone(buzzer);
    }
    
    delay(wait);
    thisNote++;
    if (thisNote >= totalNotes) {
      thisNote = 0;
    }
  }

  if(digitalRead(button2Pin) == HIGH && sensorTimer > 50 + !sensorOn * 5000) {
    Serial.println(sensorTimer);
    sensorOn = !sensorOn;
    sensorTimer = 0;
  }
  
  sensorTimer++;
 
  if(sensorOn) {
//    Serial.println(calc_dis());
    if (calc_dis() >= 15) {
      digitalWrite(led2, HIGH);
      if(sensorTimer > 5000) {
        tone(buzzer, 10, 10000);
        delay(500);
        tone(buzzer, 10, 10000);
        delay(500);
        tone(buzzer, 10, 10000);
        sensorTimer = 0;
      }
    } else {
      digitalWrite(led2, LOW);
    }
  } else {
    digitalWrite(led2, LOW);
  }
  
  HM10.listen();
  if (HM10.available() > 0) {
    appData = HM10.read();
    inData = String(appData);
    Serial.write(appData);
  }

  if (Serial.available()) {
    delay(10);
    HM10.write(Serial.read());
  }

  if (inData == "d" || digitalRead(button3Pin) == HIGH) {
    digitalWrite(led1, HIGH); // switch ON LED
    
    myservo.write(0);
    delay(300);
    myservo.write(45);

    meow();    
    
    digitalWrite(led1, LOW); // switch OFF LED
    
    Serial.print(inData);

  }
}

void playTone(uint16_t tone1, uint16_t duration) {
  if(tone1 < 50 || tone1 > 15000) return;  // these do not play on a piezo
  for (long i = 0; i < duration * 1000L; i += tone1 * 2) {
     digitalWrite(buzzer, HIGH);
     delayMicroseconds(tone1);
     digitalWrite(buzzer, LOW);
     delayMicroseconds(tone1);
  }     
}

void meow() {  // cat meow (emphasis ow "me")
  uint16_t i;
  playTone(5100,50);        // "m" (short)
  playTone(394,180);        // "eee" (long)
  for(i=990; i<1022; i+=2)  // vary "ooo" down
     playTone(i,8);
  playTone(5100,40);        // "w" (short)
}

int calc_dis()
{
  int duration,distance;
  digitalWrite(trig,HIGH);
  delay(10);
  digitalWrite(trig,LOW);
  duration=pulseIn(echo,HIGH);
  distance = (duration/2) / 29.1;
  return distance;
}
